﻿using ProjectBase.Data.BaseDAL;
using SIMDP.DAL.IDALSQL;
using SIMDP.Model;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SIMDP.BLL
{
    public class BlDataPoint : BaseBLL<MoDataPoint>
    {
        private IDalDataPoint dalDataPoint; 
         
        /// <summary>
        /// 构造函数
        /// </summary> 
        public BlDataPoint() : base()  
        {
            base.Init(this.GetType().FullName, System.Reflection.Assembly.GetExecutingAssembly().GetName().Name);

            dalDataPoint = baseDal as IDalDataPoint; 
            dalDataPoint.OnOperationLog += new OperationLogEventHandler(BlLogOperation.OnOperationLog);
        }

        /// <summary>
        ///  获取指定PLC下的数据点
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        public List<MoDataPoint> GetDataPointsByPlcID(long id)
        {
            string sql = string.Format("SELECT * FROM data_point WHERE data_point_plc_id = {0}", id);
            return dalDataPoint.GetList(sql, null);
        }

        public DataTable GetVar()
        {
            string sql = "SELECT data_point_id,data_point_name,data_point_type  from data_point";
            DataTable dt = dalDataPoint.SqlTable(sql);
            return dt;
        }
    }
}
