﻿using ProjectBase.Data.BaseDAL;
using SIMDP.DAL.IDALSQL;
using SIMDP.Model;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SIMDP.BLL
{
    public class BlDataGroup : BaseBLL<MoDataGroup>
    {
        private IDalDataGroup dalDataGroup; 

        /// <summary>
        /// 构造函数
        /// </summary> 
        public BlDataGroup() : base() 
        {
            base.Init(this.GetType().FullName, System.Reflection.Assembly.GetExecutingAssembly().GetName().Name);

            dalDataGroup = baseDal as IDalDataGroup;
            dalDataGroup.OnOperationLog += new OperationLogEventHandler(BlLogOperation.OnOperationLog);
        }

        /// <summary>
        ///  获取指定PLC下的数据点
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        public bool IsSignalGroupById(long id)
        {
            MoDataGroup dataGroup = dalDataGroup.FindByID(id);
            if (dataGroup == null)
               return false;
            else
                return (dataGroup.DataGroupType == 1);
        }
    }
}
