﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ProjectBase.Data.BaseDAL;
using ProjectBase.Data.Encrypt;
using SIMDP.DAL.IDALSQL;
using SIMDP.Model;

namespace SIMDP.BLL
{
    public class BlLogLogIn : BaseBLL<MoLogLogIn>
    {
        private IDalLogLogIn dalLogLogIn;

        /// <summary>
        /// 构造函数
        /// </summary>   
        public BlLogLogIn() : base()
        {
            base.Init(this.GetType().FullName, System.Reflection.Assembly.GetExecutingAssembly().GetName().Name);

            dalLogLogIn = baseDal as IDalLogLogIn;
        }

        /// <summary>
        /// 获取组织ID与组织名称的集合
        /// </summary>
        /// <returns></returns>
        public Dictionary<string, string> GetGroupName()
        {
            Dictionary<string, string> dic = new Dictionary<string, string>();
            //BlAuthoryGroup bl = new BlAuthoryGroup();
            List<MoAuthoryGroup> group = BLLFactory<BlAuthoryGroup>.Instance.GetAll();
            if (group.Count == 0 || group == null)
            {
                return null;
            }
            foreach (MoAuthoryGroup item in group)
            {
                dic.Add(item.GroupId,item.GroupName);
            }
            return dic;
        }
    }
}
