﻿using ProjectBase.Data.BaseDAL.BaseDatabase;
using ProjectBase.Data.Logs;
using ProjectBase.Util;
using SIMDP.DAL.IDALSQL;
using SIMDP.Model;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SIMDP.DAL.DALSQL
{
    public class DalRoleRight : BaseDALSQL<MoRoleRight>, IDalRoleRight
    {
        #region 对象实例及构造函数

        public static DalRoleRight Instance
        {
            get
            {
                return new DalRoleRight();
            } 
        }
        public DalRoleRight() : base("role_right", "role_id")
        {
            this.sortField = "role_id";
            this.isDescending = false;
        }

        #endregion 

        /// <summary>
        /// 将DataReader的属性值转化为实体类的属性值，返回实体类
        /// </summary>
        /// <param name="dr">有效的DataReader对象</param>
        /// <returns>实体类对象</returns>
        protected override MoRoleRight DataReaderToEntity(IDataReader dataReader)
        {
            MoRoleRight info = new MoRoleRight();
            SmartDataReader reader = new SmartDataReader(dataReader);
         
            info.RoleId = reader.GetString("role_id");
            info.RightId = reader.GetString("right_id");
            info.RightType = reader.GetInt32("right_type");
            return info;
        }


        /// <summary>
        /// 将实体对象的属性值转化为Hashtable对应的键值
        /// </summary>
        /// <param name="obj">有效的实体对象</param> 
        /// <returns>包含键值映射的Hashtable</returns>
        protected override Hashtable GetHashByEntity(MoRoleRight obj)
        {
            MoRoleRight info = obj as MoRoleRight;
            Hashtable hash = new Hashtable();

            hash.Add("role_id", info.RoleId);
            hash.Add("right_id", info.RightId);
            hash.Add("right_type", info.RightType);
            return hash;
        }



    }
}
