﻿using ProjectBase.Data.BaseDAL.BaseDatabase;
using ProjectBase.Util;
using SIMDP.DAL.IDALSQL;
using SIMDP.Model;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SIMDP.DAL.DALSQL
{
    public class DalRule : BaseDALSQL<MoRule>, IDalRule
    {
        #region 对象实例及构造函数

        public static DalRule Instance
        {
            get
            {
                return new DalRule(); 
            }
        }
        public DalRule() : base("rules", "rule_id")
        {
            this.sortField = "rule_id";
            this.isDescending = false;
        }

        #endregion

        /// <summary>
        /// 将DataReader的属性值转化为实体类的属性值，返回实体类
        /// </summary>
        /// <param name="dr">有效的DataReader对象</param>
        /// <returns>实体类对象</returns>
        protected override MoRule DataReaderToEntity(IDataReader dataReader)
        {
            MoRule info = new MoRule(); 
            SmartDataReader reader = new SmartDataReader(dataReader);

            info.RuleId = reader.GetInt64("rule_id");
            info.RuleName = reader.GetString("rule_name");
            info.RuleValue = reader.GetString("rule_value");
            return info;
        }


        /// <summary>
        /// 将实体对象的属性值转化为Hashtable对应的键值
        /// </summary>
        /// <param name="obj">有效的实体对象</param>
        /// <returns>包含键值映射的Hashtable</returns>
        protected override Hashtable GetHashByEntity(MoRule obj)
        {
            MoRule info = obj as MoRule;
            Hashtable hash = new Hashtable();

            //hash.Add("rule_id", info.RuleId);
            hash.Add("rule_name", info.RuleName);
            hash.Add("rule_value", info.RuleValue);

            return hash;
        }
    }
}
