﻿using ProjectBase.Data.BaseDAL.BaseDatabase;
using ProjectBase.Util;
using SIMDP.DAL.IDALSQL;
using SIMDP.Model;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SIMDP.DAL.DALSQL
{
    public class DalSystemParameter : BaseDALSQL<MoSystemParameter>, IDalSystemParameter
    {
        #region 对象实例及构造函数

        public static DalSystemParameter Instance
        {
            get
            {
                return new DalSystemParameter();
            }
        } 
        public DalSystemParameter() : base("system_parameter", "parameter_id")
        {
            this.sortField = "parameter_id";
            this.isDescending = false;
        }

        #endregion

        /// <summary>
        /// 将DataReader的属性值转化为实体类的属性值，返回实体类
        /// </summary>
        /// <param name="dr">有效的DataReader对象</param>
        /// <returns>实体类对象</returns>
        protected override MoSystemParameter DataReaderToEntity(IDataReader dataReader)
        {
            MoSystemParameter info = new MoSystemParameter();
            SmartDataReader reader = new SmartDataReader(dataReader);

            info.ParameterId = reader.GetInt32("parameter_id");
            info.ParameterName = reader.GetString("parameter_name");
            info.ParameterType = reader.GetString("parameter_type");
            info.ParameterScope = reader.GetString("parameter_scope");
            info.ParameterUnit = reader.GetString("parameter_unit");
            info.ParameterDescription = reader.GetString("parameter_description");
            info.ParameterValue = reader.GetString("parameter_value");
            info.ParameterValid = Convert.ToBoolean(reader.GetInt32("parameter_valid"));
            info.ParameterTime = reader.GetDateTime("parameter_time");
            return info;
        }


        /// <summary>
        /// 将实体对象的属性值转化为Hashtable对应的键值
        /// </summary>
        /// <param name="obj">有效的实体对象</param>
        /// <returns>包含键值映射的Hashtable</returns>
        protected override Hashtable GetHashByEntity(MoSystemParameter obj)
        {
            MoSystemParameter info = obj as MoSystemParameter;
            Hashtable hash = new Hashtable();

            //hash.Add("rule_id", info.RuleId);
            hash.Add("parameter_name", info.ParameterName);
            hash.Add("parameter_type", info.ParameterType);
            hash.Add("parameter_scope", info.ParameterScope);
            hash.Add("parameter_unit", info.ParameterUnit);
            hash.Add("parameter_description", info.ParameterDescription);
            hash.Add("parameter_value", info.ParameterValue);
            hash.Add("parameter_valid", info.ParameterValid);
            hash.Add("parameter_time", info.ParameterTime);

            return hash;
        }
    }
}
