﻿using ProjectBase.Data.BaseDAL.BaseDatabase;
using ProjectBase.Util;
using SIMDP.DAL.IDALSQL;
using SIMDP.Model;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SIMDP.DAL.DALSQL
{
    public class DalUserRole : BaseDALSQL<MoUserRole>, IDalUserRole
    {
        #region 对象实例及构造函数

        public static DalUserRole Instance
        {
            get
            {
                return new DalUserRole();
            } 
        }
        public DalUserRole() : base("user_role", "user_id")
        {
            this.sortField = "user_id";
            this.isDescending = false;
        }

        #endregion 

        /// <summary>
        /// 将DataReader的属性值转化为实体类的属性值，返回实体类
        /// </summary>
        /// <param name="dr">有效的DataReader对象</param>
        /// <returns>实体类对象</returns>
        protected override MoUserRole DataReaderToEntity(IDataReader dataReader)
        {
            MoUserRole info = new MoUserRole(); 
            SmartDataReader reader = new SmartDataReader(dataReader);

            info.UserId = reader.GetString("user_id");
            info.RoleId = reader.GetString("role_id");
            return info;
        }


        /// <summary>
        /// 将实体对象的属性值转化为Hashtable对应的键值
        /// </summary>
        /// <param name="obj">有效的实体对象</param> 
        /// <returns>包含键值映射的Hashtable</returns>
        protected override Hashtable GetHashByEntity(MoUserRole obj)
        {
            MoUserRole info = obj as MoUserRole;
            Hashtable hash = new Hashtable();

            hash.Add("user_id", info.UserId);
            hash.Add("role_id", info.RoleId);
            return hash;
        }
    }
}
