﻿using ProjectBase.Data.BaseDAL;
using ProjectBase.Data.Pager;
using SIMDP.Model;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SIMDP.DAL.IDALSQL
{
    public interface IDalPlcInfo : IBaseDAL<MoPlcInfo>
    {

        /// <summary>
        /// 获取PLC配置信息
        /// </summary>
        /// <param name="id">plc id</param>
        /// <param name="name">plc名称</param>
        /// <returns></returns>
        List<MoPlcInfo> GetAllPlcInfo();

        /// <summary>
        /// 以分页的方式获取PLC配置信息
        /// </summary>
        /// <param name="id"></param>
        /// <param name="name"></param>
        /// <param name="info">分页信息</param>
        /// <returns></returns>
        List<MoPlcInfo> GetPlcInfoWithPager(long id, string name, PagerInfo info);

        /// <summary>
        /// 插入一条PLC配置信息
        /// </summary>
        /// <param name="obj"></param>
        /// <returns></returns>
        bool InsetPlcInfo(MoPlcInfo obj);

        /// <summary>
        /// 删除记录
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        bool DeleteWithId(long id, string userId);

        /// <summary>
        /// 更新信息
        /// </summary>
        /// <param name="id"></param>
        /// <param name="newoObj"></param>
        /// <returns></returns>
        bool UpdateWithId(long id, MoPlcInfo newoObj);


    }
}
