﻿using ProjectBase.Data.BaseDAL;
using SIMDP.Util;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SIMDP.Model
{
    /// <summary>
    /// 采集数据组管理
    /// </summary>
    [Serializable]
    public class MoDataGroup: BaseEntity
    {
        public MoDataGroup()
        {
            this.CurrentLoginUserId = SysEnvironment.CurrentLoginID;
        }

        #region Field Members

        private long m_DataGroupId = 0; // 数据组ID
        private string m_DataGroupName = ""; // 数据组名称            
        private long m_DataGroupType = 0; // 数据组类型    
        private long m_DataGroupPlcId = 0; // 数据组所属PLC

        #endregion 

        #region Property Members
        /// <summary>
        /// 数据组ID
        /// </summary>
        public virtual long DataGroupId
        {
            get
            { 
                return this.m_DataGroupId;
            }
            set
            {
                this.m_DataGroupId = value;
            }
        }

        /// <summary>
        /// 数据组名称 
        /// </summary>
        public virtual string DataGroupName 
        {
            get
            {
                return this.m_DataGroupName;
            }
            set
            {
                this.m_DataGroupName = value;
            }
        }

        /// <summary>
        /// 数据组类型 
        /// </summary>
        public virtual long DataGroupType
        {
            get 
            {
                return this.m_DataGroupType;
            }
            set
            {
                this.m_DataGroupType = value;
            }
        }

        /// <summary>
        /// 数据组所属PLC 
        /// </summary>
        public virtual long DataGroupPlcId
        {
            get
            {
                return this.m_DataGroupPlcId;
            }
            set
            {
                this.m_DataGroupPlcId = value;
            }
        }
        #endregion

    }
}
