﻿using ProjectBase.Data.BaseDAL;
using SIMDP.Util;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SIMDP.Model
{
    /// <summary>
    /// 数据点管理
    /// </summary>
    [Serializable]
    public class MoDataPoint : BaseEntity
    {
        public MoDataPoint()
        {
            this.CurrentLoginUserId = SysEnvironment.CurrentLoginID;
        }

        #region Field Members

        private long m_DataPointId = 0; // 数据点ID
        private string m_DataPointName = ""; // 数据点名称           
        private long m_DataPointPlcId = 0; // 数据点PLCID      
        private long m_DataPointGroupId = 0; // 数据点采集组ID  
        private string m_DataPointSource = ""; // 数据点PLC变量名
        private long m_DataPointType = 0; // 数据点类型
        private string m_DataProc = ""; // 数据执行过程

        #endregion

        #region Property Members
        /// <summary>
        ///数据点ID
        /// </summary>
        public virtual long DataPointId 
        {
            get
            {
                return this.m_DataPointId;
            }
            set
            {
                this.m_DataPointId = value;
            }
        }

        /// <summary>
        /// 数据点名称
        /// </summary>
        public virtual string DataPointName 
        {
            get
            {
                return this.m_DataPointName;
            }
            set
            {
                this.m_DataPointName = value;
            }
        }

        /// <summary>
        /// 数据点PLCID   
        /// </summary>
        public virtual long DataPointPlcId 
        {
            get
            {
                return this.m_DataPointPlcId;
            }
            set
            {
                this.m_DataPointPlcId = value;
            }
        }

        /// <summary>
        ///  数据点采集组ID 
        /// </summary>
        public virtual long DataPointGroupId 
        {
            get
            {
                return this.m_DataPointGroupId;
            }
            set
            {
                this.m_DataPointGroupId = value;
            }
        }

        /// <summary>
        /// 数据点PLC变量名
        /// </summary>
        public virtual string DataPointSource
        {
            get
            {
                return this.m_DataPointSource;
            }
            set
            {
                this.m_DataPointSource = value;
            }
        }

        /// <summary>
        ///  数据点采集组类型
        /// </summary>
        public virtual long DataPointType 
        {
            get
            {
                return this.m_DataPointType;
            }
            set
            {
                this.m_DataPointType = value;
            }
        }

        /// <summary>
        /// 数据执行过程
        /// </summary>
        public virtual string DataProc
        { 
            get
            {
                return this.m_DataProc;
            }
            set
            {
                this.m_DataProc = value;
            }
        }
        #endregion

    }
}
