﻿using ProjectBase.Data.BaseDAL;
using SIMDP.Util;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SIMDP.Model
{
    /// <summary>
    /// PLC配置管理
    /// </summary>
    [Serializable]
    public class MoPlcInfo : BaseEntity
    {
        public MoPlcInfo()
        {
            this.CurrentLoginUserId = SysEnvironment.CurrentLoginID;
        }
        #region Field Members

        private long m_PlcId = 0; // PLCID
        private string m_PlcName = ""; // PLC名称           
        private long m_LinkType = 0; // 连接类型          
        private string m_LinkConfig = ""; // 连接信息                

        #endregion

        #region Property Members
        /// <summary>
        /// PLCID
        /// </summary>
        public virtual long PlcId 
        {
            get
            {
                return this.m_PlcId;
            }
            set
            {
                this.m_PlcId = value;
            }
        }

        /// <summary>
        /// PLC名称 
        /// </summary>
        public virtual string PlcName 
        {
            get
            {
                return this.m_PlcName;
            }
            set
            {
                this.m_PlcName = value;
            }
        }

        /// <summary>
        /// 连接类型 
        /// </summary>
        public virtual long LinkType
        {
            get
            {
                return this.m_LinkType;
            }
            set
            {
                this.m_LinkType = value;
            }
        }

        /// <summary>
        /// 连接信息
        /// </summary>
        public virtual string LinkConfig 
        {
            get
            {
                return this.m_LinkConfig;
            }
            set
            {
                this.m_LinkConfig = value;
            }
        }

      
        #endregion

    }
}
