﻿using ProjectBase.Data.BaseDAL;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SIMDP.Model
{
    /// <summary>
    /// 产品过程数据
    /// </summary>
    [Serializable]
    public class MoProductData : BaseEntity
    {
        #region Field Members 

        private long m_DataId = 0; // 产品过程数据ID
        private long m_RuleId = 0; // 规则ID
        private string m_DataValue = ""; // 产品过程数据  
        private DateTime m_RuleTime = DateTime.Now;
        private string _Batchid;

        #endregion

        #region Property Members

        /// <summary>
        ///过程数据ID
        /// </summary>
        public virtual long DataId 
        {
            get
            {
                return this.m_DataId;
            }
            set
            {
                this.m_DataId = value;
            }
        }

        /// <summary>
        ///规则ID
        /// </summary>
        public virtual long RuleId
        {
            get
            {
                return this.m_RuleId;
            }
            set
            {
                this.m_RuleId = value;
            }
        }

  

        /// <summary>
        /// 产品过程数据   
        /// </summary>
        public virtual string DataValue
        {
            get
            {
                return this.m_DataValue;
            }
            set
            {
                this.m_DataValue = value;
            }
        }


        /// <summary>
        /// 产品过程数据产生时间   
        /// </summary>
        public virtual DateTime RuleTime
        {
            get
            {
                return this.m_RuleTime;
            }
            set
            {
                this.m_RuleTime = value;
            }
        }

        public virtual string Batchid
        {
            get
            {
                return _Batchid;
            }

            set
            {
                _Batchid = value;
            }
        }
        #endregion
    }
}
