﻿using ProjectBase.Data.BaseDAL;
using SIMDP.Util;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SIMDP.Model
{
    /// <summary>
    /// 权限管理中的用户管理
    /// </summary>
    [Serializable]
    public class MoRoleRight : BaseEntity
    {
        public MoRoleRight()
        {
            this.CurrentLoginUserId = SysEnvironment.CurrentLoginID;
        }

        #region Field Members

        private string m_RoleId = ""; // 角色编码 
        private string m_RightId = ""; // 权限编码
        private int m_RightType = 1; // 权限类型

        #endregion

        #region Property Members
        /// <summary>
        /// 角色编码
        /// </summary> 
        public virtual string RoleId 
        {
            get
            {
                return this.m_RoleId;
            }
            set
            {
                this.m_RoleId = value;
            }
        }

        /// <summary>
        /// 权限编码
        /// </summary>
        public virtual string RightId
        {
            get 
            {
                return this.m_RightId;
            }
            set
            {
                this.m_RightId = value;
            }
        }

        /// <summary>
        ///权限类型
        /// </summary> 
        public virtual int RightType 
        {
            get
            {
                return this.m_RightType;
            }
            set
            {
                this.m_RightType = value;
            }
        }


        #endregion
    }
}
