﻿using ProjectBase.Data.BaseDAL;
using SIMDP.Util;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SIMDP.Model
{
    /// <summary>
    /// 系统信息提示
    /// </summary>
    [Serializable]
    public class MoSystemNotice : BaseEntity
    {
        public MoSystemNotice()
        {
            this.CurrentLoginUserId = SysEnvironment.CurrentLoginID;
        }

        #region Field Members

        private long m_ID;                     //序号
        private string m_NoticeTitle = "";     //标题
        private int m_NoticeType = 0;          //类别
        private string m_NoticeContent = "";    //内容
        private DateTime m_NoticeTime = DateTime.Now;    //发生时间
        private bool m_NoticeSign = false;       //查看标记 
        private string m_NoticeOperator = "";    //操作员

        #endregion

        #region Property Members

        /// <summary>
        /// 序号
        /// </summary>
        public virtual long ID
        {
            get
            {
                return this.m_ID;
            }
            set
            {
                this.m_ID = value;
            }
        }

        /// <summary>
        /// 标题
        /// </summary>
        public virtual string NoticeTitle
        {
            get
            {
                return this.m_NoticeTitle;
            }
            set
            {
                this.m_NoticeTitle = value;
            }
        }

        /// <summary>
        /// 类别
        /// </summary>
        public virtual int NoticeType
        {
            get
            {
                return this.m_NoticeType;
            }
            set
            {
                this.m_NoticeType = value;
            }
        }

        /// <summary>
        /// 内容
        /// </summary>
        public virtual string NoticeContent
        {
            get
            {
                return this.m_NoticeContent;
            }
            set
            {
                this.m_NoticeContent = value;
            }
        }

        /// <summary>
        /// 发生时间
        /// </summary>
        public virtual DateTime NoticeTime
        {
            get
            {
                return this.m_NoticeTime;
            }
            set
            {
                this.m_NoticeTime = value;
            }
        }

        /// <summary>
        /// 查看标记
        /// </summary>
        public virtual bool NoticeSign
        {
            get
            {
                return this.m_NoticeSign;
            }
            set
            {
                this.m_NoticeSign = value;
            }
        }

        /// <summary>
        /// 操作员
        /// </summary>
        public virtual string NoticeOperator
        {
            get
            {
                return this.m_NoticeOperator;
            }
            set
            {
                this.m_NoticeOperator = value;
            }
        }
        #endregion
    }
}
