﻿using ProjectBase.Data.BaseDAL;
using SIMDP.Util;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SIMDP.Model
{
    /// <summary>
    /// 系统参数
    /// </summary>
    [Serializable]
    public class MoSystemParameter : BaseEntity
    {
        public MoSystemParameter()
        {
            this.CurrentLoginUserId = SysEnvironment.CurrentLoginID;
        }

        #region Field Members 

        private int m_ParameterId = 0; // 参数编码
        private string m_ParameterName = ""; // 参数名称 
        private string m_ParameterType = ""; // 参数类型
        private string m_ParameterScope = ""; // 参数范围 
        private string m_ParameterUnit = ""; // 参数单位
        private string m_ParameterDescription = ""; // 参数描述     
        private string m_ParameterValue = ""; // 参数值
        private bool m_ParameterValid = false; // 参数是否有效 
        private DateTime m_ParameterTime = DateTime.Now; // 参数生效时间

        #endregion

        /// <summary>
        /// 参数编码
        /// </summary>
        public virtual int ParameterId
        {
            get
            {
                return this.m_ParameterId;
            }
            set
            {
                this.m_ParameterId = value;
            }
        }

        /// <summary>
        /// 参数名称 
        /// </summary>
        public virtual string ParameterName
        {
            get
            {
                return this.m_ParameterName;
            }
            set
            {
                this.m_ParameterName = value;
            }
        }

        /// <summary>
        /// 参数类型
        /// </summary>
        public virtual string ParameterType
        {
            get
            {
                return this.m_ParameterType;
            }
            set 
            {
                this.m_ParameterType = value;
            }
        }

        /// <summary>
        /// 参数范围
        /// </summary>
        public virtual string ParameterScope
        {
            get
            {
                return this.m_ParameterScope;
            }
            set
            {
                this.m_ParameterScope = value;
            }
        }

        /// <summary>
        /// 参数单位
        /// </summary>
        public virtual string ParameterUnit
        {
            get
            {
                return this.m_ParameterUnit;
            }
            set 
            {
                this.m_ParameterUnit = value;
            }
        }

        /// <summary>
        /// 参数描述
        /// </summary>
        public virtual string ParameterDescription
        {
            get
            {
                return this.m_ParameterDescription;
            }
            set
            {
                this.m_ParameterDescription = value;
            }
        }

        /// <summary>
        /// 参数值
        /// </summary>
        public virtual string ParameterValue
        {
            get
            {
                return this.m_ParameterValue;
            }
            set
            {
                this.m_ParameterValue = value;
            }
        }

        /// <summary>
        /// 参数是否有效
        /// </summary>
        public virtual bool ParameterValid
        {
            get
            {
                return this.m_ParameterValid;
            }
            set
            {
                this.m_ParameterValid = value;
            }
        }

        /// <summary>
        ///参数生效时间
        /// </summary>
        public virtual DateTime ParameterTime
        {
            get
            {
                return this.m_ParameterTime;
            }
            set
            { 
                this.m_ParameterTime = value;
            }
        }
    }
}
