﻿using ProjectBase.Data.BaseDAL;
using SIMDP.Util;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SIMDP.Model
{
    /// <summary>
    /// 用户参数
    /// </summary>
    [Serializable]
    public class MoUserParameter : BaseEntity
    {
        public MoUserParameter()
        {
            this.CurrentLoginUserId = SysEnvironment.CurrentLoginID;
        }

        #region Field Members 

        private int m_UserParaId = 0; // 参数编码
        private string m_UserParaName = ""; // 参数名称 
        //private string m_UserParaType = ""; // 参数类型
        //private string m_UserParaScope = ""; // 参数范围 
        private string m_UserParaUnit = ""; // 参数单位
        private string m_UserParaDescription = ""; // 参数描述     
        private string m_UserParaValue = ""; // 参数值
        private bool m_UserParaValid = false; // 参数是否有效 
        //private DateTime m_UserParaTime = DateTime.Now; // 参数生效时间
        #endregion

        /// <summary>
        /// 参数编码
        /// </summary>
        public virtual int UserParaId
        {
            get
            {
                return this.m_UserParaId;
            }
            set
            {
                this.m_UserParaId = value;
            }
        }

        /// <summary>
        /// 参数名称 
        /// </summary>
        public virtual string UserParaName
        {
            get
            {
                return this.m_UserParaName;
            }
            set
            {
                this.m_UserParaName = value;
            }
        }

        /// <summary>
        /// 参数类型
        /// </summary>
        //public virtual string UserParaType
        //{
        //    get
        //    {
        //        return this.m_UserParaType;
        //    }
        //    set
        //    {
        //        this.m_UserParaType = value;
        //    }
        //}

        /// <summary>
        /// 参数范围
        /// </summary>
        //public virtual string UserParaScope
        //{
        //    get
        //    {
        //        return this.m_UserParaScope;
        //    }
        //    set
        //    {
        //        this.m_UserParaScope = value;
        //    }
        //}

        /// <summary>
        /// 参数单位
        /// </summary>
        public virtual string UserParaUnit
        {
            get
            {
                return this.m_UserParaUnit;
            }
            set
            {
                this.m_UserParaUnit = value;
            }
        }

        /// <summary>
        /// 参数描述
        /// </summary>
        public virtual string UserParaDescription
        {
            get
            {
                return this.m_UserParaDescription;
            }
            set
            {
                this.m_UserParaDescription = value;
            }
        }

        /// <summary>
        /// 参数值
        /// </summary>
        public virtual string UserParaValue
        {
            get
            {
                return this.m_UserParaValue;
            }
            set
            {
                this.m_UserParaValue = value;
            }
        }

        /// <summary>
        /// 参数是否有效
        /// </summary>
        public virtual bool UserParaValid
        {
            get
            {
                return this.m_UserParaValid;
            }
            set
            {
                this.m_UserParaValid = value;
            }
        }

        /// <summary>
        ///参数生效时间
        /// </summary>
        //public virtual DateTime UserParaTime
        //{
        //    get
        //    {
        //        return this.m_UserParaTime;
        //    }
        //    set
        //    {
        //        this.m_UserParaTime = value;
        //    }
        //}
    }
}
