﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Linq;
using System.Threading.Tasks;
using System.Windows.Forms;
using DevExpress.XtraEditors;
using ProjectBase.Data.Encrypt;
using ProjectBase.Data.BaseDAL;
using SIMDP.BLL;
using ProjectBase.Data.Logs;

namespace SIMDP
{
    public partial class FormUserVerification : DevExpress.XtraEditors.XtraForm
    {
        public FormUserVerification()
        {
            InitializeComponent();
        }

        private void btn_Ok_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrEmpty(this.txt_Account.Text))
            {
                DevExpress.XtraEditors.XtraMessageBox.Show("请输入账号。", "提示", MessageBoxButtons.OK, MessageBoxIcon.Information);
                return;
            }
            if (string.IsNullOrEmpty(this.txt_Password.Text))
            {
                DevExpress.XtraEditors.XtraMessageBox.Show("请输入密码。", "提示", MessageBoxButtons.OK, MessageBoxIcon.Information);
                return;
            }
            try
            {
                string userid = this.txt_Account.Text.Trim();
                string passwordMD5 = EncodeHelper.EncryptString(this.txt_Password.Text);
                string message = null;
                bool flag = BLLFactory<BlAuthoryUser>.Instance.VerifyLogin(userid, passwordMD5, out message);
                if (flag)
                {
                    this.DialogResult = DialogResult.OK;
                    this.Close();
                }
                else
                {
                    DevExpress.XtraEditors.XtraMessageBox.Show(message, "提示", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    return;
                }
            }
            catch (Exception ex)
            {
                LogHelper.log.Error(string.Format("用户验证出现错误：{0}", ex.ToString()));
            }

        }
    }
}